define("customJavascript_grove", [
  "blocklylib" 
  ,"./blockly/generators/javascript"
  ,"./blockly/msg"
],function(BlocklyLib, generators, msg){

  function hexToR(h) {return parseInt((cutHex(h)).substring(0,2),16)};
  function hexToG(h) {return parseInt((cutHex(h)).substring(2,4),16)};
  function hexToB(h) {return parseInt((cutHex(h)).substring(4,6),16)};
  function cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h};
  function getPin2(pin1) {
    var pin = pin1.toUpperCase();
    switch (pin) {
      case '"B.0"':
        return '"B.1"'
        break;
      case '"B.1"':
        return '"B.2"'
        break;
      case '"B.2"':
        return '"B.3"'
        break;
      case '"B.3"':
        return '"B.4"'
        break;
      case '"B.6"':
        return '"C.0"'
        break;
      case '"B.7"':
        return '"B.5"'
        break;
      case '"C.1"':
        return '"C.2"'
        break;
      case '"C.2"':
        return '"C.3"'
        break;
      case '"C.3"':
        return '"C.7"'
        break;
      case '"C.4"':
        return '"C.5"'
        break;
      default:
        return pin
        break;
    };
  };

generators['grove_i2c_colour_sensor'] = function(block) {
  var varR = generators.variableDB_.getName(block.getFieldValue('VARR'), BlocklyLib.Variables.NAME_TYPE);
  var varG = generators.variableDB_.getName(block.getFieldValue('VARG'), BlocklyLib.Variables.NAME_TYPE);
  var varB = generators.variableDB_.getName(block.getFieldValue('VARB'), BlocklyLib.Variables.NAME_TYPE); 
  var varW = generators.variableDB_.getName(block.getFieldValue('VARW'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += varR + " = 255;\n";
  code += varG + " = 0;\n";
  code += varB + " = 0;\n";
  code += varW + " = 100;";  
  return generators.wrapOutput(block, code);
};

generators['grove_rtc'] = function(block) {
  var var1 = generators.variableDB_.getName(block.getFieldValue('VAR1'), BlocklyLib.Variables.NAME_TYPE);
  var var2 = generators.variableDB_.getName(block.getFieldValue('VAR2'), BlocklyLib.Variables.NAME_TYPE);
  var var3 = generators.variableDB_.getName(block.getFieldValue('VAR3'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += var1 + " = 0;\n";
  code += var2 + " = 0;\n";
  code += var3 + " = 0;";
  return generators.wrapOutput(block, code);
};

generators['grove_nunchuck'] = function(block) {
  var var1 = generators.variableDB_.getName(block.getFieldValue('VAR1'), BlocklyLib.Variables.NAME_TYPE);
  var var2 = generators.variableDB_.getName(block.getFieldValue('VAR2'), BlocklyLib.Variables.NAME_TYPE);
  var var3 = generators.variableDB_.getName(block.getFieldValue('VAR3'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += var1 + " = 10;\n";
  code += var2 + " = 20;\n";
  code += var3 + " = 0;";
  return generators.wrapOutput(block, code);
};

generators['grove_3axis_digital_acc'] = function(block) {
  var var1 = generators.variableDB_.getName(block.getFieldValue('VAR1'), BlocklyLib.Variables.NAME_TYPE);
  var var2 = generators.variableDB_.getName(block.getFieldValue('VAR2'), BlocklyLib.Variables.NAME_TYPE);
  var var3 = generators.variableDB_.getName(block.getFieldValue('VAR3'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += var1 + " = 10;\n";
  code += var2 + " = 20;\n";
  code += var3 + " = 30;";
  return generators.wrapOutput(block, code);
};

generators['grove_3axis_digital_acc_int'] = function(block) {
  var varI = generators.variableDB_.getName(block.getFieldValue('VARI'), BlocklyLib.Variables.NAME_TYPE);
  var varS = generators.variableDB_.getName(block.getFieldValue('VARS'), BlocklyLib.Variables.NAME_TYPE);
  //var varR = generators.variableDB_.getName(block.getFieldValue('VARR'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += varI + " = 100;\n";
  code += varS + " = '+' ;\n";
  //code += varR + " = 0;";
  return generators.wrapOutput(block, code);
};

generators['grove_3axis_digital_compass'] = function(block) {
  var var1 = generators.variableDB_.getName(block.getFieldValue('VAR1'), BlocklyLib.Variables.NAME_TYPE);
  var var2 = generators.variableDB_.getName(block.getFieldValue('VAR2'), BlocklyLib.Variables.NAME_TYPE);
  var var3 = generators.variableDB_.getName(block.getFieldValue('VAR3'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += var1 + " = 10;\n";
  code += var2 + " = 20;\n";
  code += var3 + " = 30;";
  return generators.wrapOutput(block, code);
};

generators['grove_3axis_digital_compass_int'] = function(block) {
  var varI = generators.variableDB_.getName(block.getFieldValue('VARI'), BlocklyLib.Variables.NAME_TYPE);
  var varS = generators.variableDB_.getName(block.getFieldValue('VARS'), BlocklyLib.Variables.NAME_TYPE);
  //var varR = generators.variableDB_.getName(block.getFieldValue('VARR'), BlocklyLib.Variables.NAME_TYPE); 
  var code = '';
  code += varI + " = 100;\n";
  code += varS + " = '+' ;\n";
  //code += varR + " = 0;";
  return generators.wrapOutput(block, code);
};

generators['grove_barometer_high_accuracy'] = function(block) {
    
  var varS = generators.variableDB_.getName(block.getFieldValue('VARS'), BlocklyLib.Variables.NAME_TYPE);
  var varI = generators.variableDB_.getName(block.getFieldValue('VARI'), BlocklyLib.Variables.NAME_TYPE);
  var varR = generators.variableDB_.getName(block.getFieldValue('VARR'), BlocklyLib.Variables.NAME_TYPE);
  var cmd = block.getFieldValue('COMMAND');
  
  var code = '';
  code += varS + " = '+';\n";
  code += varI + " = 20;\n";
  code += varR + " = 0;";
  return generators.wrapOutput(block, code);
};    

generators['grove_temperature_humidity'] = function(block) {
  var varT = generators.variableDB_.getName(block.getFieldValue('VART'), BlocklyLib.Variables.NAME_TYPE);
  var varH = generators.variableDB_.getName(block.getFieldValue('VARH'), BlocklyLib.Variables.NAME_TYPE);
  var code = ";";
  return generators.wrapOutput(block, code);
};    

generators['grove_serial_lcd_print'] = function(block) {
  var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
  if (!value) value = 0;
  if ( value[0] != '"' ) {
    //value = "#" + value;
  }
  var code = "picaxe.serial.EUSART.write(0," + value + ");";
  return generators.wrapOutput(block, code);
};

generators['grove_serial_lcd_command'] = function(block) {
  var codetag = block.getFieldValue('CODETAG');
  var code = "picaxe.serial.EUSART.write(0,[ "+codetag + " ]);";
  if ( codetag == "254, 1" ) {
    code += generators.getInnerStepCode(block);
    code += "picaxe.pause(10);";
  }
  return generators.wrapOutput(block, code);
};

generators['grove_oled_print'] = function(block) {
  var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
  if (!value) value = 0;
  if ( value[0] != '"' ) {
    value = 0; //TODO value = "#" + value;
  }  
  var code = 'picaxe.i2c.write(0x40, [ ' + value + ' ]);';
  return generators.wrapOutput(block, code);
};

generators['grove_oled_plot'] = function (block) {
  var row = generators.valueToCode(block, 'ROW', generators.ORDER_ATOMIC) - 1;
  var col = generators.valueToCode(block, 'COL', generators.ORDER_ATOMIC) - 1;
  var pin = generators.getPinName(block);
  var code = 'picaxe.i2c.write(0x40, [ ' + row + ', ' + col + ' ]);';
  return generators.wrapOutput(block, code);
};

generators['grove_oled_command'] = function(block) {
  var codetag = block.getFieldValue('CODETAG');
  if (codetag.length > 4) {
    codetag = 0x00; //TODO value = "#" + value;
  }
  var code = 'picaxe.i2c.write(0x80, [ ' + codetag + ' ]);';
  return generators.wrapOutput(block, code);
};

generators['grove_rgb_lcd_print'] = function(block) {
  var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
  if (!value) value = 0;
  if ( value[0] != '"' ) {
    value = 0; //TODO value = "#" + value;
  }  
  var code = 'picaxe.i2c.write(0x40, [ ' + value + ' ]);';
  return generators.wrapOutput(block, code);
};

generators['grove_rgb_lcd_command'] = function(block) {
  var codetag = block.getFieldValue('CODETAG');
  if (codetag.length > 4) {
    codetag = 0x00; //TODO value = "#" + value;
  }
  var code = 'picaxe.i2c.write(0x80, [ ' + codetag + ' ]);';
  return generators.wrapOutput(block, code);
};

generators['grove_rgb_lcd_color'] = function(block) {
  var colour_rgb = block.getFieldValue('RGB');
  var colourRGB = hexToR(colour_rgb)+", "+hexToG(colour_rgb)+", "+hexToB(colour_rgb);  
  var code = 'picaxe.i2c.write(0x40, [ ' + colourRGB + ' ]);';
  return generators.wrapOutput(block, code);
};

generators['grove_4_digit_display'] = function(block) {
  var pin = generators.getPinName(block);
  var value = 1;
  var code = "picaxe.pin.write(" + pin + "," + value + ");";
  return generators.wrapOutput(block, code);
};

generators['grove_led_bar'] = function(block) {
  var pin = generators.getPinName(block);
  var value = 1;
  var code = "picaxe.pin.write(" + pin + "," + value + ");";
  return generators.wrapOutput(block, code);
};

generators['grove_circular_led'] = function(block) {
  var pin = generators.getPinName(block);
  var value = 1;
  var code = "picaxe.pin.write(" + pin + "," + value + ");";
  return generators.wrapOutput(block, code);
};

  generators['grove_bluetooth_receive'] = function (block) {
    var varName = generators.variableDB_.getName(block.getFieldValue('NAME'), BlocklyLib.Variables.NAME_TYPE);
    var code = varName + " = picaxe.serial.EUSART.read();";
    return generators.wrapOutput(block, code);
  };

  generators['grove_bluetooth_send'] = function (block) {
    var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
    if (!value) value = 0;
    var code = "picaxe.serial.EUSART.write(0," + value + ");\n";
    code += generators.getInnerStepCode(block);
    code += "picaxe.pause(100);";
    return generators.wrapOutput(block, code);
  };

generators['grove_mp3_v2'] = function(block) {
  var pin = "B.0";
  var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
  var cmd = block.getFieldValue('COMMAND');
  var  code = "";

  if (cmd=="play") {
   if (!value) value = 0;
   code += "picaxe.serial.EUSART.write(0,0);";
  }
  else if (cmd=="stop") {
   code += "picaxe.serial.EUSART.write(0,0);";
  }
  else if (cmd=="pause") {
   code += "picaxe.serial.EUSART.write(0,0);";
  }
  else if (cmd=="resume") {
   code += "picaxe.serial.EUSART.write(0,0);";
  }
  else if (cmd=="volume") {
   code += "picaxe.serial.EUSART.write(0,0);";
  }
  return generators.wrapOutput(block, code);
};  
  
  generators['grove_i2c_motor'] = function (block) {
    var code = "picaxe.pause(100);"; //TODO
    return generators.wrapOutput(block, code);
  };  
  
});